Loading...
Searching...
No Matches
openshot::Pixelate Class Reference

This class pixelates an image, and can be animated with openshot::Keyframe curves over time. More...

`#include <effects/Pixelate.h>`

Inheritance diagram for openshot::Pixelate:

## Public Member Functions

std::shared_ptr< openshot::Frame > | GetFrame (int64_t frame_number) override
| This method is required for all derived classes of ClipBase, and returns a new openshot::Frame object. All Clip keyframes and effects are resolved into pixels.
std::shared_ptr< openshot::Frame > | GetFrame (std::shared_ptr< openshot::Frame > frame, int64_t frame_number) override
| This method is required for all derived classes of ClipBase, and returns a modified openshot::Frame object.
std::string | Json () const override
| Generate JSON string of this object.
Json::Value | JsonValue () const override
| Generate Json::Value for this object.
| Pixelate ()
| Default constructor, useful when using Json to load the effect properties.
| Pixelate (Keyframe pixelization, Keyframe left, Keyframe top, Keyframe right, Keyframe bottom)
std::string | PropertiesJSON (int64_t requested_frame) const override
void | SetJson (const std::string value) override
| Load JSON string into this object.
void | SetJsonValue (const Json::Value root) override
| Load Json::Value into this object.
Public Member Functions inherited from openshot::EffectBase
Json::Value | BasePropertiesJSON (int64_t requested_frame) const
| Generate JSON object of base properties (recommended to be used by all effects)
int | constrain (int color_value)
| Constrain a color value from 0 to 255.
void | DisplayInfo (std::ostream *out=&std::cout)
| Display effect information in the standard output stream (stdout)
virtual std::string | GetVisibleObjects (int64_t frame_number) const
| Get the indexes and IDs of all visible objects in the given frame.
void | InitEffectInfo ()
virtual std::string | Json (int64_t requested_frame) const
Json::Value | JsonInfo () const
| Generate JSON object of meta data / info.
int | Order () const
| Get the order that this effect should be executed.
void | Order (int new_order)
| Set the order that this effect should be executed.
openshot::ClipBase * | ParentClip ()
| Parent clip object of this effect (which can be unparented and NULL)
void | ParentClip (openshot::ClipBase *new_clip)
| Set parent clip object of this effect.
std::string | ParentClipId () const
| Return the ID of this effect's parent clip.
virtual void | SetJson (int64_t requested_frame, const std::string value)
void | SetParentEffect (std::string parentEffect_id)
| Set the parent effect from which this properties will be set to.
virtual | ~EffectBase ()=default
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip.
float | Duration () const
| Get the length of this clip (in seconds)
virtual float | End () const
| Get end position (in seconds) of clip (trim end of video)
virtual void | End (float value)
| Set end position (in seconds) of clip (trim end of video)
std::string | Id () const
| Get the Id of this clip object.
void | Id (std::string value)
int | Layer () const
| Get layer of clip on timeline (lower number is covered by higher numbers)
void | Layer (int value)
| Set layer of clip on timeline (lower number is covered by higher numbers)
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
virtual openshot::TimelineBase * | ParentTimeline ()
| Get the associated Timeline pointer (if any)
virtual void | ParentTimeline (openshot::TimelineBase *new_timeline)
| Set associated Timeline pointer.
float | Position () const
| Get position on timeline (in seconds)
void | Position (float value)

> ‍Set the Id of this clip object

float | Start () const
| Get start position (in seconds) of clip (trim start of video)
void | Start (float value)
| Set start position (in seconds) of clip (trim start of video)
virtual | ~ClipBase ()=default

## Public Attributes

Keyframe | bottom
| Size of bottom margin.
Keyframe | left
| Size of left margin.
Keyframe | pixelization
| Amount of pixelization.
Keyframe | right
| Size of right margin.
Keyframe | top
| Size of top margin.
Public Attributes inherited from openshot::EffectBase
EffectInfoStruct | info
| Information about the current effect.
EffectBase * | parentEffect
| Parent effect (which properties will set this effect properties)
std::map< int, std::shared_ptr< openshot::TrackedObjectBase > > | trackedObjects
| Map of Tracked Object's by their indices (used by Effects that track objects on clips)

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (std::string name, int value, int selected_value) const
| Generate JSON choice for a property (dropdown properties)
Json::Value | add_property_json (std::string name, float value, std::string type, std::string memo, const Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame) const
| Generate JSON for a property.
Protected Attributes inherited from openshot::EffectBase
openshot::ClipBase * | clip
| Pointer to the parent clip instance (if any)
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip)
std::string | id
| ID Property for all derived Clip and Effect classes.
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips.
float | position
| The position on the timeline where this clip should start playing.
std::string | previous_properties
| This string contains the previous JSON properties.
float | start
| The position in seconds to start playing (used to trim the beginning of a clip)
openshot::TimelineBase * | timeline
| Pointer to the parent timeline instance (if any)

## Detailed Description

This class pixelates an image, and can be animated with openshot::Keyframe curves over time.

Pixelating the image is the process of increasing the size of visible pixels, thus loosing visual clarity of the image. The area to pixelate can be set and animated with keyframes also.

Definition at line 34 of file Pixelate.h.

## Constructor & Destructor Documentation

## Pixelate() [1/2]

Pixelate::Pixelate | ( |  | ) |

Default constructor, useful when using Json to load the effect properties.

Blank constructor, useful when using Json to load the effect properties.

Definition at line 25 of file Pixelate.cpp.

## Pixelate() [2/2]

Pixelate::Pixelate | ( | Keyframe | pixelization,
|  | Keyframe | left,
|  | Keyframe | top,
|  | Keyframe | right,
|  | Keyframe | bottom
| ) |  |

Cnstructor which takes 5 curves. These curves animate the pixelization effect over time.

Parameters

  pixelization | The curve to adjust the amount of pixelization (0 to 1)
  left | The curve to adjust the left margin size (between 0 and 1)
  top | The curve to adjust the top margin size (between 0 and 1)
  right | The curve to adjust the right margin size (between 0 and 1)
  bottom | The curve to adjust the bottom margin size (between 0 and 1)

Definition at line 31 of file Pixelate.cpp.

## Member Function Documentation

## GetFrame() [1/2]

std::shared_ptr< openshot::Frame > openshot::Pixelate::GetFrame | ( | int64_t | frame_number | ) |

inline override virtual

This method is required for all derived classes of ClipBase, and returns a new openshot::Frame object. All Clip keyframes and effects are resolved into pixels.

Returns
  A new openshot::Frame object

Parameters

  frame_number | The frame number (starting at 1) of the clip or effect on the timeline.

Implements openshot::ClipBase.

Definition at line 67 of file Pixelate.h.

Referenced by GetFrame().

## GetFrame() [2/2]

std::shared_ptr< openshot::Frame > Pixelate::GetFrame | ( | std::shared_ptr< openshot::Frame > | frame,
|  | int64_t | frame_number
| ) |  |

override virtual

This method is required for all derived classes of ClipBase, and returns a modified openshot::Frame object.

The frame object is passed into this method and used as a starting point (pixels and audio). All Clip keyframes and effects are resolved into pixels.

Returns
  The modified openshot::Frame object

Parameters

  frame | The frame object that needs the clip or effect applied to it
  frame_number | The frame number (starting at 1) of the clip or effect on the timeline.

Implements openshot::ClipBase.

Definition at line 55 of file Pixelate.cpp.

## Json()

std::string Pixelate::Json | ( |  | ) | const

override virtual

Generate JSON string of this object.

Reimplemented from openshot::EffectBase.

Definition at line 93 of file Pixelate.cpp.

## JsonValue()

Json::Value Pixelate::JsonValue | ( |  | ) | const

override virtual

Generate Json::Value for this object.

Reimplemented from openshot::EffectBase.

Definition at line 100 of file Pixelate.cpp.

Referenced by Json().

## PropertiesJSON()

std::string Pixelate::PropertiesJSON | ( | int64_t | requested_frame | ) | const

override virtual

Get all properties for a specific frame (perfect for a UI to display the current state of all properties at any time)

Implements openshot::ClipBase.

Definition at line 152 of file Pixelate.cpp.

## SetJson()

void Pixelate::SetJson | ( | const std::string | value | ) |

override virtual

Load JSON string into this object.

Reimplemented from openshot::EffectBase.

Definition at line 116 of file Pixelate.cpp.

## SetJsonValue()

void Pixelate::SetJsonValue | ( | const Json::Value | root | ) |

override virtual

Load Json::Value into this object.

Reimplemented from openshot::EffectBase.

Definition at line 133 of file Pixelate.cpp.

Referenced by SetJson().

## Member Data Documentation

## bottom

Keyframe openshot::Pixelate::bottom

Size of bottom margin.

Definition at line 46 of file Pixelate.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## left

Keyframe openshot::Pixelate::left

Size of left margin.

Definition at line 43 of file Pixelate.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## pixelization

Keyframe openshot::Pixelate::pixelization

Amount of pixelization.

Definition at line 42 of file Pixelate.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## right

Keyframe openshot::Pixelate::right

Size of right margin.

Definition at line 45 of file Pixelate.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## top

Keyframe openshot::Pixelate::top

Size of top margin.

Definition at line 44 of file Pixelate.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

The documentation for this class was generated from the following files:

- effects/Pixelate.h
- effects/Pixelate.cpp